// compileopts.sbt: shared scalac/javac options.
// Copyright (C) 2012-2014 Stephen Compall
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

import CrossVersion.partialVersion
import Opts.compile._

scalacOptions in ThisBuild ++= Seq(
  deprecation, unchecked
) ++ encoding("UTF-8")
// TODO consider -Xlint
// *or* -Ywarn-nullary-override -Ywarn-inaccessible
// -Yno-imports -Yno-predef are also interesting

scalacOptions in ThisBuild ++= {
  partialVersion(scalaVersion.value) match {
    case Some((2, 9)) => Seq("-Ydependent-method-types")
    case _ =>
      Seq("-Yno-adapted-args", "-feature",
          "-language:implicitConversions", "-language:higherKinds",
          "-language:existentials", "-language:postfixOps")
  }
}

scalacOptions in ThisBuild ++= {
  import scala.math.Ordering.Implicits.infixOrderingOps
  partialVersion(scalaVersion.value) match {
    case Some((2, 10)) => Seq("-Xdivergence211")
    case Some(x) if x >= ((2, 11)) =>
      Seq("-Ywarn-unused", "-Ywarn-unused-import")
    case _ => Seq.empty[String]
  }
}

scalacOptions in (Compile, console) in ThisBuild ~=
  (_ filterNot Set("-Ywarn-unused", "-Ywarn-unused-import"))

javacOptions in (Compile, compile) in ThisBuild ++=
  Seq("-encoding", "UTF-8", "-Xlint", "-Werror")
