package hcavsc.hk

import scalaz.{Kleisli, Monad, Monoid}
import scalaz.std.tuple._

object KWS {
  type KWConcrete[W, A, B] = Kleisli[(W, ?), A, B]

  sealed abstract class KWImpl {
    type T[W, A, B]
    
    def subst[F[_[_, _, _]]](fk: F[KWConcrete]): F[T]
  }

  val KW: KWImpl = new KWImpl {
    type T[W, A, B] = KWConcrete[W, A, B]
    
    override def subst[F[_[_, _, _]]](fk: F[KWConcrete]) = fk
  }

  type KW[W, A, B] = KW.T[W, A, B]

  implicit def monadKW[W: Monoid, A]: Monad[KW[W, A, ?]] = {
    type MF[KWC[_, _, _]] = Monad[KWC[W, A, ?]]
    // KW.subst[MF](implicitly) with better inference
    KW.subst[MF](Kleisli.kleisliMonadReader[(W, ?), A])
  }
}
