package hcavsc.ints

object MagicInts {
  sealed abstract class MagicIntImpl {
    type T
    def apply(i: Int): T
    def subst[F[_]](fi: F[Int]): F[T]
  }

  // do not forget `: MagicIntImpl`; it is key
  val MagicInt: MagicIntImpl = new MagicIntImpl {
    type T = Int
    override def apply(i: Int) = i
    override def subst[F[_]](fi: F[Int]) = fi
  }

  type MagicInt = MagicInt.T
}

import MagicInts._

abstract class OtherTests {
  def bytecodeFor = {
    val x = MagicInt(42)
    List(x, x)
    val xs = List(42)
    val mxs = MagicInt.subst(xs)
    val y: MagicInt = mxs.head
  }

  def myId(x: MagicInt): MagicInt
}
