package hcavsc.translucent

object Labels {
  sealed abstract class LabelImpl {
    type T <: String
    def apply(s: String): T
    def unwrap(lbl: T): String
  }
  
  // do not forget `: LabelImpl`; it is key
  val Label: LabelImpl = new LabelImpl {
    type T = String
    override def apply(s: String) = s
    override def unwrap(lbl: T) = lbl
  }

  type Label = Label.T
}

import Labels._

class MyFirstTests {
  def combineLabels(l: Label, r: Label): Label =
    Label(l + r)
}

object OtherTests {
  val untaggedList = List("hello", "world")
  val taggedList: List[Label] = untaggedList map Label.apply

  val thenUntagged: List[String] = taggedList

  def report(xs: List[String]): Unit = ()

  val lReport: List[Label] => Unit = report
}
