package hcavsc.translucentints

object MagicInts {
  sealed abstract class MagicIntImpl {
    type T <: Int
    def apply(i: Int): T
    def subst[F[_]](fi: F[Int]): F[T]
  }

  // do not forget `: MagicIntImpl`; it is key
  val MagicInt: MagicIntImpl = new MagicIntImpl {
    type T = Int
    override def apply(i: Int) = i
    override def subst[F[_]](fi: F[Int]) = fi
  }

  type MagicInt = MagicInt.T
}

import MagicInts._

abstract class OtherTests {
  def myId(x: MagicInt): MagicInt
}
